/*	serviceStream.cpp (c) mordillo ´06
	GPL bla wie gewohnt */


#ifndef DISABLE_FILE

#include <config.h>
#include <lib/dvb/serviceStream.h>
#include <lib/dvb/servicefile.h>
#include <lib/system/init.h>
#include <lib/system/init_num.h>
#include <lib/base/i18n.h>
#include <lib/gdi/fb.h>
#include <lib/system/econfig.h>
#include <lib/system/info.h>
#include <lib/movieplayer/movieplayer.h>
#include <src/enigma_mount.h>
#include <unistd.h>
#include <fcntl.h>
#include <sys/ioctl.h>
#include <sys/stat.h>
#include <errno.h>
#include <stdio.h>

eServiceHandlerSTREAM::eServiceHandlerSTREAM(): eServiceHandler(0x5000)
{
	if (eServiceInterface::getInstance()->registerHandler(id, this) < 0)
		eFatal("couldn't register serviceHandler %d", id);
	CONNECT(eServiceFileHandler::getInstance()->fileHandlers, eServiceHandlerSTREAM::addFile);
}

eServiceHandlerSTREAM::~eServiceHandlerSTREAM()
{
	eServiceInterface::getInstance()->unregisterHandler(id);
}

void eServiceHandlerSTREAM::addFile(void *node, const eString &filename)
{
#ifdef HAVE_DREAMBOX_HARDWARE
	if (eSystemInfo::getInstance()->getHwType() >= eSystemInfo::DM7000)
	{
#endif
		if (filename.right(4).upper() == ".AVI")
		{
			struct stat s;
			if (!(::stat(filename.c_str(), &s)))
			{
				eServiceReference ref(id, 0, filename);
				ref.descr = filename.substr(filename.find_last_of("/") + 1, filename.length() - 1);
				ref.flags |= eServiceReference::isNotPlayable;
				eServiceFileHandler::getInstance()->addReference(node, ref);
			}
		}
#ifdef HAVE_DREAMBOX_HARDWARE
	}
#endif
}

int eServiceHandlerSTREAM::play(const eServiceReference &service, int workaround )
{
	if (!workaround)
	{
		bool foundone=false;
		eString sdir;
		eString activeMount;
		eString strMount;
		eString file2Play;
		FILE *fp;
			char path[256];
			fp = popen("mount", "r");
			while (fgets(path, 256, fp) != NULL)
			{
				sdir.sprintf("%s", path);
				if (sdir.find("on /var/mnt") != eString::npos)
				{
					foundone=true;
					break;
				}
			}
		pclose(fp);

		if(foundone)
		{
			int pos1=sdir.find_last_of(":")+1;
			int pos2=sdir.find(" on /var/mnt") - 15;
			int pos=service.path.find_last_of("/");
			activeMount=sdir.mid( pos1, pos2 );
			file2Play+=activeMount;
			file2Play+=service.path.mid(pos);
			eDebug("[serviceStream] File is: %s", file2Play.c_str());
			if (eMoviePlayer::getInstance()->status.STAT != eMoviePlayer::STOPPED)
				eMoviePlayer::getInstance()->control("terminate", "");
			eMoviePlayer::getInstance()->control("start2",  file2Play.c_str());
			//foundone=false;
		}
		else
		{
			eDebug("[serviceStream]: No valid Mountpoint found. Use /mnt as mountpoint");
			return 0;
		}
	}
	
}

int eServiceHandlerSTREAM::stop(int workaround)
{
	/*if (eMoviePlayer::getInstance()->status.STAT != eMoviePlayer::STOPPED)
		eMoviePlayer::getInstance()->control("terminate", "");
	else*/
		return 0;

}

eService *eServiceHandlerSTREAM::addRef(const eServiceReference &service)
{
	return eServiceFileHandler::getInstance()->addRef(service);
}

void eServiceHandlerSTREAM::removeRef(const eServiceReference &service)
{
	return eServiceFileHandler::getInstance()->removeRef(service);
}

eAutoInitP0<eServiceHandlerSTREAM> i_eServiceHandlerSTREAM(eAutoInitNumbers::service + 2, "eServiceHandlerSTREAM");

#endif //DISABLE_FILE
